import React from 'react';
declare type CircularProgressbarDefaultProps = {
    strokeWidth: number;
    className: string;
    text: string;
    background: boolean;
    backgroundPadding: number;
    initialAnimation: boolean;
    counterClockwise: boolean;
    classes: {
        root: string;
        trail: string;
        path: string;
        text: string;
        background: string;
    };
    styles: {
        root?: object;
        trail?: object;
        path?: object;
        text?: object;
        background?: object;
    };
};
declare type CircularProgressbarProps = CircularProgressbarDefaultProps & {
    percentage: number;
};
declare type CircularProgressbarState = {
    percentage: number;
};
declare class CircularProgressbar extends React.Component<CircularProgressbarProps, CircularProgressbarState> {
    initialTimeout: number | undefined;
    requestAnimationFrame: number | undefined;
    static defaultProps: CircularProgressbarDefaultProps;
    constructor(props: CircularProgressbarProps);
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: CircularProgressbarProps): void;
    componentWillUnmount(): void;
    getBackgroundPadding(): number;
    getPathDescription(): string;
    getPathStyles(): {
        strokeDasharray: string;
        strokeDashoffset: string;
    };
    getPathRadius(): number;
    render(): JSX.Element;
}
export default CircularProgressbar;
